//========================================================================================
//
//	File:				FWFilRep.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWFILREP_H
#define FWFILREP_H

#ifndef FWEXCDEF_H
#include "FWExcDef.h"
#endif

#ifndef FWFILE_H
#include "FWFileSy.h"
#endif

#ifndef FWFILESP_H
#include "FWFileSp.h"
#endif

#include "SLFilRep.xh"

//========================================================================================
//	FW_PFile
//
//	Class holding representation for FW_OFile.  This is an implementation class 
//    and should not be used in general.  Use the FW_CFileSink class instead.
//========================================================================================



//========================================================================================
// CLASS FW_PFile
//========================================================================================

class FW_PFile : public FW_TCountedSOMPtr<FW_OFile>
{
public:
	virtual ~FW_PFile();

	FW_PFile(Environment* ev, FW_OFile* privFileAccessRep);
		
	FW_PFile(Environment* ev, 
			 FW_OFileSpecification* fileSpecification,
			 FW_Boolean allowCreate = FALSE);
		// Open with exclusive access 

	FW_PFile(Environment* ev, 
			 FW_OFileSpecification* fileSpecification,
			 const FW_SAccessPermission& permission,
			 FW_Boolean allowCreate = FALSE);
		// Open with specified permissions.
};
		
#endif
