//========================================================================================
//
//	File:				FWFileAc.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWFILEAC_H
#define FWFILEAC_H

#ifndef FWRANSIN_H
#include "FWRanSin.h"
#endif

#include "SLFileAc.xh"

//========================================================================================
//	CLASS FW_PFileSink
//
//		Inherited API for operator->()
//			long GetReadableBytes();
//			void Read(in void * destination, in long count);
//			long GetWritableBytes();
//			void Write(in void* source, in long count);
//
//			long GetLength();
//			void SetLength(in long length);
//			long GetPosition();
//			void SetPosition(in long position);
//
//		New API for operator->()
//			FW_OFile GetOFileRep();
//
//========================================================================================

class FW_PFileSink : public FW_PRandomAccessSink
{
public:
	FW_PFileSink(Environment* ev, FW_OFileSink* theFileSink);
	FW_PFileSink(Environment* ev, FW_OFile* theFile);

	virtual ~FW_PFileSink();

	FW_OFileSink* operator->() const;

private:
	FW_PFileSink(const FW_PFileSink&);
	FW_PFileSink& operator=(const FW_PFileSink&);
};


//----------------------------------------------------------------------------------------
//	FW_PFileSink::operator->
//----------------------------------------------------------------------------------------
inline FW_OFileSink* FW_PFileSink::operator->() const
{
	return (FW_OFileSink*)GetRep();
}

#endif
