//========================================================================================
//
//	File:				FWFontLi.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================


#ifndef FWFONTLI_H
#define FWFONTLI_H

#ifndef FWSTRING_H
#include "FWString.h"
#endif

#ifndef FWEXCLIB_H
#include "FWExcLib.h"
#endif

#ifndef FWTCOLL_H
#include "FWTColl.h"
#endif

//========================================================================================
// CLASS FW_CFontList
//========================================================================================

class FW_CFontList
{
public:
	FW_DECLARE_AUTO(FW_CFontList)
	friend class FW_CFontIterator;

	FW_CFontList();
	virtual ~FW_CFontList();
	
private:
	FW_TOrderedCollection<FW_CString>	fCollection;
};

//========================================================================================
// CLASS FW_CFontInterator
//========================================================================================

class FW_CFontIterator
{
public:
	FW_DECLARE_AUTO(FW_CFontIterator)

	FW_CFontIterator(); 
	FW_CFontIterator(FW_CFontList* fontList); 
	virtual ~FW_CFontIterator();

	FW_CString	First();
		// Returns an empty string if the list is empty
	FW_CString	Next();
		// Returns an empty string if at the end of the list
	FW_CString	Last();
		// Returns an empty string if the list is empty
	FW_CString	Previous();
		// Return an empty string if at the beginning of the list
	
	FW_Boolean			IsNotComplete();

private:
	FW_CFontList*								fFontList;
	FW_Boolean									fDeleteTheList;
	FW_TOrderedCollectionIterator<FW_CString>*	fIterator;
};

#endif


