//========================================================================================
//
//	File:				FWGConst.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWGCONST_H
#define FWGCONST_H

// ----- OpenDoc Includes -----

#ifndef FWODTYPS_H
#include "FWODTyps.h"
#endif

// ----- Macintosh Includes -----

#if defined(FW_BUILD_MAC) && !defined(__QUICKDRAW__)
#include <QuickDraw.h>
#endif

// ----- Windows Includes -----

#if defined(FW_BUILD_WIN) && !defined(_INC_WINDOWS)
#include <windows.h>
#endif

// ----- ODF Includes -----

#ifndef FWPAT_H
#include "FWPat.h"
#endif

#ifndef SLGCONST_K
#include "SLGConst.k"
#endif

//========================================================================================
//	Forward Declarations
//========================================================================================

class	FW_CColor;
class	FW_CString32;
class	FW_CPoint;
class	FW_CRect;

//========================================================================================
//	Graphic System
//========================================================================================

#ifdef FW_BUILD_MAC
const ODGraphicsSystem FW_kGraphicSystem = kODQuickDraw;
#endif

#ifdef FW_BUILD_WIN
const ODGraphicsSystem FW_kGraphicSystem = kODWindows;
#endif

//========================================================================================
//	Globals
//========================================================================================

// ----- Standard colors -----
extern const FW_SColor			FW_kRGBBlack;
extern const FW_SColor			FW_kRGBWhite;
extern const FW_SColor			FW_kRGBRed;
extern const FW_SColor			FW_kRGBYellow;
extern const FW_SColor			FW_kRGBBlue;
extern const FW_SColor			FW_kRGBGreen;
extern const FW_SColor			FW_kRGBBrown;
extern const FW_SColor			FW_kRGBPurple;
extern const FW_SColor			FW_kRGBLightBlue;
extern const FW_SColor			FW_kRGBGray;
extern const FW_SColor			FW_kRGBLightGray;
extern const FW_SColor			FW_kRGBDarkGray;

// ----- Standard Patterns -----
extern const FW_BitPattern		FW_kBlackPat;
extern const FW_BitPattern		FW_kWhitePat;
extern const FW_BitPattern		FW_kGrayPat;
extern const FW_BitPattern		FW_kLightGrayPat;
extern const FW_BitPattern		FW_kDarkGrayPat;
extern const FW_BitPattern		FW_kHorizontalPat;
extern const FW_BitPattern		FW_kVerticalPat;
extern const FW_BitPattern		FW_kFDiagonalPat;
extern const FW_BitPattern		FW_kBDiagonalPat;
extern const FW_BitPattern		FW_kCrossPat;
extern const FW_BitPattern		FW_kDiagCrossPat;
extern const FW_BitPattern		FW_kAntPat;

// ------ Standard font names -----
extern const FW_CString32		FW_kSystemFont;
extern const FW_CString32		FW_kDefaultFont;
extern const FW_CString32		FW_kHelvetica;
extern const FW_CString32		FW_kTimes;
extern const FW_CString32		FW_kCourier;
extern const FW_CString32		FW_kPalatino;

#endif
