//========================================================================================
//
//	File:				FWGrRef.tpp
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWGRREF_H
#include "FWGrRef.h"
#endif

//========================================================================================
//	class FW_TGrRefPtr
//========================================================================================

//----------------------------------------------------------------------------------------
//	FW_TGrRefPtr<T>::FW_TGrRefPtr
//----------------------------------------------------------------------------------------

template <class T>
FW_TGrRefPtr<T>::FW_TGrRefPtr(T rep)
{
	fRep = rep;
	FW_PrivAcquireGrRep(rep);
	FW_END_CONSTRUCTOR
}

//----------------------------------------------------------------------------------------
//	FW_TGrRefPtr<T>::FW_TGrRefPtr
//----------------------------------------------------------------------------------------

template <class T>
FW_TGrRefPtr<T>::FW_TGrRefPtr(const FW_TGrRefPtr<T>& other)
{
	fRep = other.fRep;
	FW_PrivAcquireGrRep(other.fRep);
	FW_END_CONSTRUCTOR
}

//----------------------------------------------------------------------------------------
//	FW_TGrRefPtr<T>::~FW_TGrRefPtr
//----------------------------------------------------------------------------------------

template <class T>
FW_TGrRefPtr<T>::~FW_TGrRefPtr()
{
	FW_START_DESTRUCTOR
	FW_PrivReleaseGrRep(fRep);
}

//----------------------------------------------------------------------------------------
//	FW_TGrRefPtr<T>::SetRep
//----------------------------------------------------------------------------------------

template <class T>
void FW_TGrRefPtr<T>::SetRep(T rep)
{
	FW_PrivAcquireGrRep(rep);
	FW_PrivReleaseGrRep(fRep);
	fRep = rep;
}
