//========================================================================================
//
//	File:				FWWinDIB.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWWINDIB_H
#define FWWINDIB_H

#ifndef FWSTDDEF_H
#include "FWStdDef.h"
#endif

#ifdef FW_BUILD_WIN

#ifndef SLWINDIB_H
#include "SLWinDIB.h"
#endif

//========================================================================================
// DIB utilities
//========================================================================================

unsigned short
SL_API		FW_DIBAcquireColorTable(FW_WinDIB dib, FW_SColor** colors);

HBITMAP
SL_API		FW_DIBConvertToBitmap(FW_WinDIB dib, HPALETTE hPal);

FW_WinDIB
SL_API		FW_DIBConvertFromBitmap(HBITMAP bitmapHandle, short bitDepth, HPALETTE hPal);

HPALETTE
SL_API		FW_DIBGetPalette(FW_WinDIB dib);

FW_WinDIB
SL_API		FW_DIBCreate(
				short bitDepth, short width, short height,
				short nbColors, const FW_SColor* colorTable,
				const void* pixels);

FW_WinDIB
SL_API		FW_DIBCreateCopy(FW_WinDIB dib);

FW_WinDIB
SL_API		FW_DIBLoadFromStream(FW_CReadableStream& stream, FW_Boolean bFileHeader);

void
SL_API		FW_DIBSaveToStream(FW_CWritableStream& stream, FW_WinDIB dib, FW_Boolean bFileHeader);

#endif // FW_BUILD_WIN

#endif // FWWINDIB_H
