//========================================================================================
//
//	File:				SLGDev.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef SLGDEV_H
#define SLGDEV_H

#ifndef FWSTDDEF_H
#include "FWStdDef.h"
#endif

#ifndef FWFXMATH_H
#include "FWFxMath.h"
#endif

#ifndef SLGCONST_K
#include "SLGConst.k"
#endif

#ifndef SLSHATTR_H
#include "SLShAttr.h"
#endif

#ifndef SLGRDEF_H
#include "SLGrDef.h"
#endif

#ifndef SLPTRECT_H
#include "SLPtRect.h"
#endif

// ----- OpenDoc Includes -----

#ifndef SOM_ODCanvas_xh
#include <Canvas.xh>
#endif

#ifndef SOM_ODTransform_xh
#include <Trnsform.xh>
#endif

//========================================================================================
// Related types
//========================================================================================

struct FW_SPrivDeviceState;
struct FW_SPrivSuspendResumeState;

#ifdef FW_BUILD_MAC
#define FW_SPrivSuspendResumeState	FW_SPrivDeviceState
#endif

//========================================================================================
// Graphics device
//========================================================================================

class FW_CPrivGraphicsDevice;
typedef FW_CPrivGraphicsDevice* FW_HGDevice;

// Export or Import functions for CFM-68K [sfu]

#if defined(FW_ODFLIB_IMPORT)
#pragma import on
#elif defined(FW_ODFLIB)
#pragma export on
#endif

FW_EXTERN_C_BEGIN

// Creation

FW_HGDevice			SL_API		FW_PrivGDev_CreateFromODCanvas(Environment *ev, ODCanvas* odCanvas);
FW_HGDevice			SL_API		FW_PrivGDev_CreateFromPlatformCanvas(Environment *ev, ODPlatformCanvas platformCanvas);

// Ref counting

void				SL_API		FW_PrivGDev_Acquire(FW_HGDevice gdev);
void				SL_API		FW_PrivGDev_Release(FW_HGDevice gdev);

// Attributes

ODPlatformCanvas	SL_API		FW_PrivGDev_GetPlatformCanvas(FW_HGDevice gdev);
FW_PlatformError	SL_API		FW_PrivGDev_GetFontMetrics(FW_HGDevice gdev, FW_HFont font, FW_PlatformFontMetrics& metrics);
FW_PlatformError	SL_API		FW_PrivGDev_GetResolution(FW_HGDevice gdev, FW_SPoint& pt);

// Suspend/resume

FW_SPrivSuspendResumeState*		SL_API	FW_PrivGDev_Suspend(FW_HGDevice gdev, FW_PlatformError* error);
void							SL_API	FW_PrivGDev_Resume(FW_HGDevice gdev, FW_SPrivSuspendResumeState *suspendResumeState, FW_PlatformError* error);

// Operations

FW_PlatformError	SL_API		FW_PrivGDev_SetResolution(FW_HGDevice gdev, FW_Fixed x, FW_Fixed y);
void				SL_API		FW_PrivGDev_CanvasChanged(FW_HGDevice gdev, Environment *ev, ODCanvas* canvas);

FW_EXTERN_C_END

// For CFM-68K [sfu]

#if defined(FW_ODFLIB_IMPORT)
#pragma import off
#elif defined(FW_ODFLIB)
#pragma export off
#endif


#endif // SLGDEV_H
