//========================================================================================
//
//	File:				SLIcon.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef SLICON_H
#define SLICON_H

#ifndef FWSTDDEF_H
#include "FWStdDef.h"
#endif

#ifndef SLGRDEF_H
#include "SLGrDef.h"
#endif

#ifndef SLPTRECT_H
#include "SLPtRect.h"
#endif

#ifndef SLSTRMRW_H
#include "SLStrmRW.h"
#endif

//========================================================================================
//	Forward Declarations
//========================================================================================

class FW_OResourceFile;
struct FW_SGraphicContext;

class FW_CPrivIconRep;
typedef FW_CPrivIconRep* FW_HIcon;

//========================================================================================
// Extern C Methods
//========================================================================================

// Export or Import functions for CFM-68K [sfu]

#if defined(FW_ODFLIB_IMPORT)
#pragma import on
#elif defined(FW_ODFLIB)
#pragma export on
#endif


FW_EXTERN_C_BEGIN

// Creation

FW_HIcon			SL_API	FW_PrivIcon_CreateFromPlatformIcon(
								FW_PlatformIcon 	hIcon,
								FW_PlatformError* 	error);

FW_HIcon			SL_API	FW_PrivIcon_CreateFromResource(
								FW_OResourceFile* 	resourceFile,
								FW_ResourceId 		resId,
								short 				size,
								FW_PlatformError* 	error);

FW_HIcon			SL_API	FW_PrivIcon_Copy(FW_HIcon icon, FW_PlatformError* error);

// Reference counting

void				SL_API	FW_PrivIcon_Acquire(FW_HIcon icon);
long				SL_API	FW_PrivIcon_GetRefCount(FW_HIcon icon);
void				SL_API	FW_PrivIcon_Release(FW_HIcon icon);

// Comparison

FW_Boolean			SL_API	FW_PrivIcon_IsEqual(FW_HIcon icon, FW_HIcon icon2);

// Get, Set, Adopt and Orphan

FW_PlatformIcon		SL_API	FW_PrivIcon_GetPlatformIcon(FW_HIcon icon);
FW_PlatformIcon		SL_API	FW_PrivIcon_OrphanPlatformIcon(FW_HIcon icon);
FW_Boolean			SL_API	FW_PrivIcon_IsPlatformIconOrphan(FW_HIcon icon);

FW_PlatformError	SL_API	FW_PrivIcon_SetPlatformIcon(FW_HIcon icon, FW_PlatformIcon newIcon);
FW_PlatformError	SL_API	FW_PrivIcon_AdoptPlatformIcon(FW_HIcon icon, FW_PlatformIcon newIcon);
	
// Size

void				SL_API	FW_PrivIcon_GetIconSize(FW_HIcon icon, FW_SPoint& size);
void				SL_API	FW_PrivIcon_GetIconSizeGC(Environment* ev, FW_HIcon icon, FW_SGraphicContext& gc, FW_SPoint& size);

// Streaming

FW_HIcon			SL_API	FW_PrivIcon_Read(FW_HReadableStream stream, FW_PlatformError* error);
void				SL_API	FW_PrivIcon_Write(FW_HIcon icon, FW_HWritableStream stream, FW_PlatformError* error);

FW_EXTERN_C_END

// For CFM-68K [sfu]

#if defined(FW_ODFLIB_IMPORT)
#pragma import off
#elif defined(FW_ODFLIB)
#pragma export off
#endif

#endif // SLICON_H
