//========================================================================================
//
//	File:				FWGrInit.cpp
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#include "FWOS.hpp"

#ifndef FWGRINIT_H
#include "FWGrInit.h"
#endif

#ifndef SLGRGLOB_H
#include "SLGrGlob.h"
#endif

#ifndef FWRECT_H
#include "FWRect.h"
#endif

#ifndef FWGXUTIL_H
#include "FWGXUtil.h"
#endif

#ifndef FWPRIDEB_H
#include "FWPriDeb.h"
#endif

#if defined(FW_BUILD_MAC) && !defined(__WINDOWS__)
#include <Windows.h>
#endif

//========================================================================================
//	RunTime Info
//========================================================================================

#ifdef FW_BUILD_MAC
#pragma segment FWGraphics_Init
#endif

//========================================================================================
//	Global Functions
//========================================================================================

//----------------------------------------------------------------------------------------
// FW_PrivInitGraphics
//----------------------------------------------------------------------------------------

void FW_PrivInitGraphics()
{
	FW_PrivInitializeGraphicsGlobals();

#ifdef FW_SUPPORT_GX
	FW_Priv_GX_Initialize();
#endif
}

//----------------------------------------------------------------------------------------
// FW_PrivShutdownGraphics
//----------------------------------------------------------------------------------------

void FW_PrivShutdownGraphics()
{
	FW_PrivTerminateGraphicsGlobals();

#ifdef FW_SUPPORT_GX
	FW_Priv_GX_Terminate();
#endif
}
