//========================================================================================
//
//	File:				FWODGeom.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:			(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWODGEOM_H
#define FWODGEOM_H

#ifndef PRODGEOM_H
#include "PRODGeom.h"
#endif

#ifndef FWODEXCE_H
#include "FWODExce.h"
#endif

#ifndef FWPOINT_H
#include "FWPoint.h"
#endif

#ifndef FWRECT_H
#include "FWRect.h"
#endif

//========================================================================================
//	Forward Declarations
//========================================================================================

class ODFrame;
class ODShape;
class ODTransform;

//========================================================================================
//	Global Utilities
//========================================================================================

// ----- ODShape utilities -----

ODShape* 		FW_XorODShape(Environment* ev, ODShape* a, ODShape* d);

ODRgnHandle		FW_GetShapeRegion(Environment *ev, ODShape* odShape);
void 			FW_SetShapeRegion(Environment *ev, ODShape* odShape, ODRgnHandle rgnHandleToAdopt);

FW_CRect		FW_GetShapeBoundingBox(Environment *ev, ODShape* odShape);

// Create C++ wrappers for the "extern C" transform and shape creation functions
ODShape* 		FW_NewODShape(Environment* ev);
ODShape*		FW_NewODShape(Environment *ev, ODShape* otherShape);
ODShape*		FW_NewODShape(Environment *ev, const FW_CRect& rect);
ODShape*		FW_NewODShape(Environment *ev, const FW_SPlatformRect& rect);
ODShape*		FW_NewODShape(Environment *ev, ODRgnHandle rgnHandleToAdopt);

ODTransform* 	FW_NewODTransform(Environment* ev);
ODTransform* 	FW_NewODTransform(Environment *ev, ODTransform* otherTransform);
ODTransform* 	FW_NewODTransform(Environment *ev, const FW_CPoint& offset);
ODTransform* 	FW_NewODTransform(Environment *ev, const FW_CPoint& offset, const FW_CPoint& scale);

#endif

