//========================================================================================
//
//	File:				PRODGeom.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef PRODGEOM_H
#define PRODGEOM_H

#ifndef SLPTRECT_H
#include "SLPtRect.h"
#endif

//========================================================================================
//	Forward Declarations
//========================================================================================

class ODFrame;
class ODShape;
class ODTransform;

//========================================================================================
//	Global Utilities
//========================================================================================

// Export or Import functions for CFM-68K [sfu]

#if defined(FW_ODFLIB_IMPORT)
#pragma import on
#elif defined(FW_ODFLIB)
#pragma export on
#endif

FW_EXTERN_C_BEGIN

void  			SL_API		FW_PrivSetShapeTransformMaker(Environment *ev, ODFrame* odFrame);

// ----- ODShape utilities -----

ODShape*  		SL_API		FW_PrivNewODShape_Empty(Environment* ev);
ODShape*		SL_API		FW_PrivNewODShape_Shape(Environment *ev, ODShape* otherShape);
ODShape*		SL_API		FW_PrivNewODShape_Rect(Environment *ev, const FW_SRect& rect);
ODShape*		SL_API		FW_PrivNewODShape_PlatformRect(Environment *ev, const FW_SPlatformRect& rect);
ODShape*		SL_API		FW_PrivNewODShape_Region(Environment *ev, ODRgnHandle rgnHandleToAdopt);

// ----- ODTransform utilities -----

ODTransform*  	SL_API		FW_PrivNewODTransform_Empty(Environment* ev);
ODTransform* 	SL_API		FW_PrivNewODTransform_Transform(Environment *ev, ODTransform* otherTransform);
ODTransform* 	SL_API		FW_PrivNewODTransform_Point(Environment *ev, const FW_SPoint& offset);
ODTransform* 	SL_API		FW_PrivNewODTransform_Point2(Environment *ev, const FW_SPoint& offset, const FW_SPoint& scale);

FW_EXTERN_C_END

// For CFM-68K [sfu]

#if defined(FW_ODFLIB_IMPORT)
#pragma import off
#elif defined(FW_ODFLIB)
#pragma export off
#endif

#endif // SLODGEOM_H
