//========================================================================================
//
//	File:				SLPtRect.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:			(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef SLPTRECT_H
#define SLPTRECT_H

#ifndef FWFXMATH_H
#include "FWFxMath.h"
#endif

// ----- Foundation Includes -----

#ifndef FWSTDDEF_H
#include "FWStdDef.h"
#endif

//========================================================================================
// struct FW_SPoint
// 	Has the same layout as ODPoint, but the members are FW_Fixed instead of ODFixed.
//	This is how we can pass points accross SOM and C boundaries
//========================================================================================

struct FW_SPoint
{
	FW_Fixed	x;
	FW_Fixed	y;
};

//========================================================================================
// struct FW_SRect
//	Has the same layout as ODRect, but uses type-safe FW_Fixed instead of ODFixed
//========================================================================================

struct FW_SRect
{
	FW_Fixed left;
	FW_Fixed top;
	FW_Fixed right;
	FW_Fixed bottom;
};

#endif // SLPTRECT_H
