//========================================================================================
//
//	File:				FWFileOp.cpp
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#include "FWOS.hpp"

#ifndef FWFILEOP_H
#include "FWFileOp.h"
#endif

//========================================================================================
//	Runtime Informations
//========================================================================================

#ifdef FW_BUILD_MAC	
#pragma segment fwosmisc
#endif

//========================================================================================
//	CLASS FW_COpenFileParameters
//========================================================================================

FW_DEFINE_AUTO(FW_COpenFileParameters)

//----------------------------------------------------------------------------------------
//	FW_COpenFileParameters default constructor
//----------------------------------------------------------------------------------------

FW_COpenFileParameters::FW_COpenFileParameters()
{
	::FW_FailOnError(FW_OpenFileParameters_Construct(&fRep));
	FW_END_CONSTRUCTOR
}

//----------------------------------------------------------------------------------------
//	FW_COpenFileParameters::~FW_COpenFileParameters
//----------------------------------------------------------------------------------------

FW_COpenFileParameters::~FW_COpenFileParameters()
{
	FW_START_DESTRUCTOR
	::FW_FailOnError(FW_OpenFileParameters_Destruct(&fRep));
}

#ifdef FW_BUILD_MAC
//----------------------------------------------------------------------------------------
//	FW_COpenFileParameters::FW_COpenFileParameters
//----------------------------------------------------------------------------------------

// [ODF2] should be changed to ODSType fileType
FW_COpenFileParameters::FW_COpenFileParameters(OSType* fileType, 
											   FileFilterProcPtr fileFilterProc)
{
	::FW_FailOnError(FW_OpenFileParameters_Construct(&fRep));
	::FW_FailOnError(FW_OpenFileParameters_MacSet(&fRep, 1, fileType, fileFilterProc));
	FW_END_CONSTRUCTOR
}

FW_COpenFileParameters::FW_COpenFileParameters(FileFilterProcPtr fileFilterProc)
{
	::FW_FailOnError(FW_OpenFileParameters_Construct(&fRep));
	::FW_FailOnError(FW_OpenFileParameters_MacSet(&fRep, -1, NULL, fileFilterProc));
	FW_END_CONSTRUCTOR
}

FW_COpenFileParameters::FW_COpenFileParameters(short numTypes,
											   OSType *fileType, 
											   FileFilterProcPtr fileFilterProc)
{
	::FW_FailOnError(FW_OpenFileParameters_Construct(&fRep));
	::FW_FailOnError(FW_OpenFileParameters_MacSet(&fRep, numTypes, fileType, fileFilterProc));
	FW_END_CONSTRUCTOR
}
#endif

#ifdef FW_BUILD_WIN
//----------------------------------------------------------------------------------------
//	FW_COpenFileParameters::FW_COpenFileParameters
//----------------------------------------------------------------------------------------

FW_COpenFileParameters::FW_COpenFileParameters(const FW_CString& filterString,
											   const FW_CString& defaultExt,
											   HWND ownerWindow)
{
	::FW_FailOnError(FW_OpenFileParameters_Construct(&fRep));
	::FW_FailOnError(FW_OpenFileParameters_WinInit(&fRep, filterString, defaultExt, ownerWindow));
	FW_END_CONSTRUCTOR
}
#endif

//========================================================================================
//	CLASS FW_CSaveFileParameters
//========================================================================================

FW_DEFINE_AUTO(FW_CSaveFileParameters)

//----------------------------------------------------------------------------------------
//	FW_CSaveFileParameters default constructor
//----------------------------------------------------------------------------------------
FW_CSaveFileParameters::FW_CSaveFileParameters()
{
	::FW_FailOnError(FW_SaveFileParameters_Construct(&fRep));
	FW_END_CONSTRUCTOR
}

//----------------------------------------------------------------------------------------
//	FW_CSaveFileParameters destructor
//----------------------------------------------------------------------------------------
FW_CSaveFileParameters::~FW_CSaveFileParameters()
{
	FW_START_DESTRUCTOR
	::FW_FailOnError(FW_SaveFileParameters_Destruct(&fRep));
}

#ifdef FW_BUILD_MAC
//----------------------------------------------------------------------------------------
//	FW_CSaveFileParameters constructor
//----------------------------------------------------------------------------------------
FW_CSaveFileParameters::FW_CSaveFileParameters(const FW_CString& savePrompt,
											   const FW_CString& defaultName)
{
	::FW_FailOnError(FW_SaveFileParameters_Construct(&fRep));
	::FW_FailOnError(FW_SaveFileParameters_MacInit(&fRep, savePrompt, defaultName));
	FW_END_CONSTRUCTOR
}
#endif

#ifdef FW_BUILD_WIN
//----------------------------------------------------------------------------------------
//	FW_CSaveFileParameters constructor
//----------------------------------------------------------------------------------------
FW_CSaveFileParameters::FW_CSaveFileParameters(const FW_CString& filterString,
											   const FW_CString& defaultExt,
											   const FW_CString& defaultName,
							   				   HWND ownerWindow)
{
	::FW_FailOnError(FW_SaveFileParameters_Construct(&fRep));
	::FW_FailOnError(FW_SaveFileParameters_WinInit(&fRep, filterString, defaultExt, defaultName, ownerWindow));
	FW_END_CONSTRUCTOR
}
#endif

