//========================================================================================
//
//	File:				FWResSin.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWRESSIN_H
#define FWRESSIN_H

#ifndef FWSOMPTR_H
#include "FWSOMPtr.h"
#endif

#ifndef FWEXCDEF_H
#include "FWExcDef.h"
#endif

#ifndef FWRANSIN_H
#include "FWRanSin.h"
#endif

#include "SLResSin.xh"

//========================================================================================
// CLASS FW_PResourceSink
//	This class owns an FW_OResourceSink*.  The constructor creates one, the destructor 
//	deletes it.
//
//		Inherited API for operator->()
//			long GetReadableBytes();
//			void Read(in void * destination, in long count);
//			long GetWritableBytes();
//			void Write(in void* source, in long count);
//
//			long GetLength();
//			void SetLength(in long length);
//			long GetPosition();
//			void SetPosition(in long position);
//
//========================================================================================

class FW_PResourceSink : public FW_PRandomAccessSink
{
public:
	FW_PResourceSink(Environment* ev, FW_OResourceSink* theResourceSink);
	FW_PResourceSink(Environment* ev, FW_OResource* theResource);

	virtual ~FW_PResourceSink();

private:
	FW_PResourceSink(const FW_PResourceSink&);
	FW_PResourceSink& operator=(const FW_PResourceSink&);
};

#endif
