//========================================================================================
//
//	File:				FWAlert.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWALERT_H
#define FWALERT_H

#ifndef FWALTDEF_H
#include "FWAltDef.h"
#endif

// ----- Windows includes -----

#if defined(FW_BUILD_WIN) && !defined(_INC_WINDOWS)
#include <Windows.h>
#endif

//========================================================================================
// Forward Class Declaration
//========================================================================================

class FW_CString;

//========================================================================================
// FW_Alert
//========================================================================================

FW_AlertResult FW_Alert(const FW_CString& documentName,
									const FW_CString& message,
									FW_ButtonType buttonType,
									FW_IconType iconType,
									FW_DefaultButton defaultButton,
									FW_Boolean beep);
										
FW_AlertResult FW_NoteAlert(const FW_CString& documentName, 
									const FW_CString& message);
									
FW_AlertResult FW_QuestionAlert(const FW_CString& documentName, 
									const FW_CString& message, 
									FW_DefaultButton defaultButton);
									
FW_AlertResult FW_ErrorAlert(const FW_CString& documentName, 
									const FW_CString& message);

//========================================================================================
// FW_Alert Inlines
//========================================================================================

//----------------------------------------------------------------------------------------
//	FW_NoteAlert
//----------------------------------------------------------------------------------------
inline FW_AlertResult FW_NoteAlert(const FW_CString& documentName, const FW_CString& message)
{
	return FW_Alert(documentName, message, FW_kOK, FW_kNoteAlert, FW_kDefaultButton1, TRUE);
}

//----------------------------------------------------------------------------------------
//	FW_QuestionAlert
//----------------------------------------------------------------------------------------
inline FW_AlertResult FW_QuestionAlert(const FW_CString& documentName, 
										const FW_CString& message,
										FW_DefaultButton defaultButton)
{
	return FW_Alert(documentName, message, FW_kYesNo, FW_kCautionAlert, defaultButton, TRUE);
}

//----------------------------------------------------------------------------------------
//	FW_ErrorAlert
//----------------------------------------------------------------------------------------
inline FW_AlertResult FW_ErrorAlert(const FW_CString& documentName, const FW_CString& message)
{
	return FW_Alert(documentName, message, FW_kOK, FW_kStopAlert, FW_kDefaultButton1, TRUE);
}

#endif
