//========================================================================================
//
//	File:				FWAltDef.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWALTDEF_H
#define FWALTDEF_H

// ----- Windows includes -----

#if defined(FW_BUILD_WIN) && !defined(_INC_WINDOWS)
#include <Windows.h>
#endif

//========================================================================================
//	Constants
//========================================================================================

typedef short FW_AlertResult;
typedef short FW_ButtonType;
typedef short FW_IconType;
typedef short FW_DefaultButton;

#ifdef FW_BUILD_MAC
const FW_ButtonType FW_kOK					= 0x0000;
const FW_ButtonType FW_kOKCancel 			= 0x0001;
const FW_ButtonType FW_kAbortRetryIgnore 	= 0x0002;
const FW_ButtonType FW_kYesNoCancel 		= 0x0003;
const FW_ButtonType FW_kYesNo 				= 0x0004;
const FW_ButtonType FW_kRetryCancel 		= 0x0005;

const FW_IconType FW_kStopAlert 			= 0x0010;
const FW_IconType FW_kCautionAlert 			= 0x0020;
const FW_IconType FW_kNoteAlert 			= 0x0040;
	
const FW_DefaultButton FW_kDefaultButton1 	= 0x0000;
const FW_DefaultButton FW_kDefaultButton2 	= 0x0100;
const FW_DefaultButton FW_kDefaultButton3 	= 0x0200;
	
enum EAlertResultConstants
{
	FW_kOKButtonPressed 		= 1,
	FW_kCancelButtonPressed 	= 2,
	FW_kAbortButtonPressed 		= 3,
	FW_kRetryButtonPressed 		= 4,
	FW_kIgnoreButtonPressed 	= 5,
	FW_kYesButtonPressed 		= 6,
	FW_kNoButtonPressed 		= 7
};
#endif

#ifdef FW_BUILD_WIN
const FW_ButtonType FW_kOK					= MB_OK;
const FW_ButtonType FW_kOKCancel 			= MB_OKCANCEL;
const FW_ButtonType FW_kAbortRetryIgnore 	= MB_ABORTRETRYIGNORE;
const FW_ButtonType FW_kYesNoCancel 		= MB_YESNOCANCEL;
const FW_ButtonType FW_kYesNo 				= MB_YESNO;
const FW_ButtonType FW_kRetryCancel 		= MB_RETRYCANCEL;
	
const FW_IconType FW_kStopAlert				= MB_ICONHAND;
const FW_IconType FW_kCautionAlert 			= MB_ICONQUESTION;
const FW_IconType FW_kNoteAlert 			= MB_ICONASTERISK;
	
const FW_DefaultButton FW_kDefaultButton1 	= MB_DEFBUTTON1;
const FW_DefaultButton FW_kDefaultButton2 	= MB_DEFBUTTON2;
const FW_DefaultButton FW_kDefaultButton3 	= MB_DEFBUTTON3;

enum EAlertResultConstants
{
	FW_kOKButtonPressed 		= IDOK ,
	FW_kCancelButtonPressed 	= IDCANCEL,
	FW_kAbortButtonPressed 		= IDABORT ,
	FW_kRetryButtonPressed 		= IDRETRY,
	FW_kIgnoreButtonPressed 	= IDIGNORE,
	FW_kYesButtonPressed 		= IDYES,
	FW_kNoButtonPressed 		= IDNO
};
#endif
	
#endif
