//========================================================================================
//
//	File:				PRWinPro.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef PRWINPRO_H
#define PRWINPRO_H

#ifndef FWSTDDEF_H
#include "FWStdDef.h"
#endif

#ifndef SLPTRECT_H
#include "SLPtRect.h"
#endif

//========================================================================================
//	Forward Declarations
//========================================================================================

class ODFrame;

//========================================================================================
//	struct FW_SWindowProperties
//========================================================================================

struct FW_SWindowProperties
{
	FW_Boolean			fHasWindowProperties;
	
#ifdef FW_BUILD_MAC
	short  				fMacProcID;
	FW_Boolean 			fMacHasCloseBox;
	long   				fMacRefCon;
	Str255 				fMacTitle;
#endif

	FW_SRect 			fBoundsRect;
	FW_Boolean 			fIsResizable;
	FW_Boolean 			fWasVisible;
	FW_Boolean 			fIsFloating;
	FW_Boolean 			fIsRootWindow;
	FW_Boolean 			fShouldShowLinks;
	ODFrame*  			fSourceFrame;
};

//========================================================================================
//	global Function
//========================================================================================

FW_EXTERN_C_BEGIN

#if defined(FW_ODFLIB_IMPORT)
#pragma import on
#elif defined(FW_ODFLIB)
#pragma export on
#endif

FW_Boolean SL_API		FW_PrivReadWindowProperties(Environment* ev, FW_SWindowProperties* windowProperties, ODFrame* frame);
FW_PlatformError SL_API	FW_PrivInitWindowProperties(FW_SWindowProperties* windowProperties);

#if defined(FW_ODFLIB_IMPORT)
#pragma import off
#elif defined(FW_ODFLIB)
#pragma export off
#endif

FW_EXTERN_C_END

#endif
