//========================================================================================
//
//	File:				FWOS.hpp
//	Release Version:	$ ODF 1 $
//
//	Copyright:			(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWOS_HPP
#define FWOS_HPP

#ifndef FW_USE_PRECOMPILED_HEADERS
#define FW_USE_PRECOMPILED_HEADERS 0
#endif

#ifndef FW_AGGRESSIVE_PRECOMPILE
#define FW_AGGRESSIVE_PRECOMPILE 0
#endif

#ifndef FW_PRECOMPILE_PRIVATE_HEADERS
#define FW_PRECOMPILE_PRIVATE_HEADERS 0
#endif

//========================================================================================
//	Always needed includes
//========================================================================================

#ifndef FWENVDEF_H
#include "FWEnvDef.h"	// Est muss sein?  Muss est sein!
#endif

// NOTICE: This include needs to be first because it defines the SOMCHKEXCEPT
// which the SOM generated C++ binding classes use to check and throw our
// kind of exceptions.

#ifndef FWODEXCE_H
#include "FWODExce.h"
#endif

//========================================================================================
//	Layer Includes
//========================================================================================

#if FW_USE_PRECOMPILED_HEADERS

// ----- OpenDoc Includes -----

#ifndef SOM_ODShape_xh
#include <Shape.xh>
#endif

#ifndef SOM_ODTransform_xh
#include <Trnsform.xh>
#endif

#ifndef SOM_ODCanvas_xh
#include <Canvas.xh>
#endif

#ifndef SOM_ODFacet_xh
#include <Facet.xh>
#endif

#ifndef SOM_ODWindow_xh
#include <Window.xh>
#endif

#ifndef SOM_ODPersistentObject_xh
#include <PstObj.xh>
#endif

// ----- Foundation Includes -----

#ifndef FWFOUND_H
#include "FWFound.h"
#endif

// ----- OS Includes -----

// We consider precompiling headers in this layer for this layer aggressive,
// as opposed to just precompiling things this layer uses.

#if FW_AGGRESSIVE_PRECOMPILE

#ifndef FWOS_H
#include "FWOS.h"
#endif

#endif // FW_AGGRESSIVE_PRECOMPILE

#endif // FW_USE_PRECOMPILED_HEADERS

#endif // FWOS_HPP


